//+------------------------------------------------------------------+
//|                                           Candlestick - Doji.mq4 |
//|                                                            Hermo |
//|                                      http://www.tradingunited.es |
//+------------------------------------------------------------------+
#property copyright "Hermo"
#property link      "http://www.tradingunited.es"
#property version   "1.00"


#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Gold
#property indicator_width1 2


extern string    IndicatorName               = "=== Candlestick - Doji ===";
extern double    TamaoMinimoColaSuperior    =  3;            
extern double    TamaoMinimoColaInferior    =  3;            
extern double    TamaoMaximoCuerpoVela      =  1;

extern string    Alerta                      = "=== Alerta ===";
extern bool      OnAlert                     =  true;

extern string    Caja                        = "=== Caja ===";
extern bool      DibujarCajaEnVela           =  true;         
extern color     ColorCaja                   =  Gold;      

extern string    Senal                       = "=== Seal ===";
extern bool      MostrarSeal                =  true;          
extern color     ColorSeal                  =  Gold;          
extern int       TamaoSeal                 =  2;            

extern string    Texto                       = "=== Texto ==="; 
extern bool      MostrarTexto                =  true;          
extern color     ColorTexto                  =  White;         
extern int       TamaoTexto                 =  8;            
extern bool      TextoVertical               =  false;         


//+------------------------------------------------------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------------------------------------------------------+

//Initialization For Variables

string   name              = "Candlestick - Doji";
int      counter           = 1;
int      digit             = 0;
double   pipMultiplier     = 1;
double   distancia         = 0;
double   H                 = 0.0;
double   L                 = 0.0;
double   C                 = 0.0;
double   O                 = 0.0;
datetime T                 = 0;
bool     Doji              = true;
bool     sound1            = false;


double  pPoint;
string  s_symbol;


//+------------------------------------------------------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------------------------------------------------------+

int init()

{
   ObjectCreate   (name, OBJ_LABEL, 0, 0, 0);
   ObjectSet      (name, OBJPROP_XDISTANCE, 15);
   ObjectSet      (name, OBJPROP_YDISTANCE, 21);
   ObjectSetText  (name, "Candlestick - Doji", 8, "Tahoma", Gold);
    
   
   s_symbol = Symbol();
   pPoint = MarketInfo(s_symbol,MODE_POINT);
   
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) pipMultiplier = 1;
   if (digit==3 || digit==5) pipMultiplier = 10;
   if (digit==6)             pipMultiplier = 100;
   switch (Period())
         {
          case 1:     distancia = 10  * digit; break;
          case 5:     distancia = 15  * digit; break;
          case 15:    distancia = 25  * digit; break;
          case 30:    distancia = 35  * digit; break;
          case 60:    distancia = 45  * digit; break;
          case 240:   distancia = 75  * digit; break;
          case 1440:  distancia = 175 * digit; break;
          case 10080: distancia = 230 * digit; break;
          case 43200: distancia = 350 * digit; break;
         }
         
 return(0);
}

//+------------------------------------------------------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------------------------------------------------------+

int deinit()
  {

   ObjectsDeleteAll(0, OBJ_LABEL);
   ObjectsDeleteAll(0, OBJ_TREND);
   ObjectsDeleteAll(0, OBJ_RECTANGLE);
   ObjectsDeleteAll(0, OBJ_ARROW);
   ObjectsDeleteAll(0, OBJ_TEXT);

   return(0);
  }  
   
//+------------------------------------------------------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------------------------------------------------------+

int start()

{
   int i, counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   for(i=Bars-1; i>0; i--)
   
  {

    H = High[i]; 
    L = Low[i]; 
    C = Close[i]; 
    O = Open[i];
    T = Time[i];
    
    if(Doji)    
      {
        if(H-C >= TamaoMinimoColaSuperior * digit && C-L >= TamaoMinimoColaInferior * digit && MathAbs(C-O) <= TamaoMaximoCuerpoVela * digit)
         
            {
              
             if(DibujarCajaEnVela) 
               {
                if(ObjectFind("Caja" + counter) == -1)
                  {
                   ObjectCreate("Caja" + counter, OBJ_RECTANGLE, 0, Time[i+1], High[i]+(MathMin(Open[i], Close[i])-Low[i])/2, Time[i-1], Low[i]-(MathMin(Open[i], Close[i])-Low[i])/2);                     
                   ObjectSet   ("Caja" + counter, OBJPROP_COLOR, ColorCaja);
                  }
               } 
             if(MostrarSeal)
               {
                if(ObjectFind("Seal"+counter)==-1)
                  {
                   ObjectCreate("Seal" + counter, OBJ_ARROW, 0, Time[i], High[i]+(MathMin(Open[i], Close[i])-Low[i])/2 + distancia, 0);
                   ObjectSet   ("Seal" + counter, OBJPROP_ARROWCODE, 244);
                   ObjectSet   ("Seal" + counter, OBJPROP_COLOR, ColorSeal);
                   ObjectSet   ("Seal" + counter, OBJPROP_WIDTH, TamaoSeal);
                  }
               } 
             if(MostrarTexto)
               {
                if(ObjectFind("Texto" + counter)==-1)
                  {
                   ObjectCreate ("Texto" + counter, OBJ_TEXT, 0, Time[i], Low[i] - distancia);
                   ObjectSetText("Texto" + counter, name, TamaoTexto, "Tahoma", ColorTexto);
                   
                   if(TextoVertical) 
                   ObjectSet("Texto" + counter, OBJPROP_ANGLE, 90);
                  }  
                }
              counter++;
            }
       } 
         
    if(!OnAlert) return(0);
    if(Volume[0]>1) return(0);
    H=High[1]; 
    L=Low[1]; 
    C=Close[1]; 
    O=Open[1];
    
    if(Doji)
      {
       if(H-C >= TamaoMinimoColaSuperior * digit && C-L >= TamaoMinimoColaInferior * digit && MathAbs(C-O) <= TamaoMaximoCuerpoVela * digit) 
        {   
         Alert("Nuevo Doji",Symbol(),"M",Period());         
        }
      }  

  } 
   return(0);
}

//+------------------------------------------------------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------------------------------------------------------+